#include "header.h"


namespace dds1
{	
	// IUnknown methods       
	HRESULT __stdcall QueryInterface( WRAP* wrap, const IID& riid, void** ppvObject ) 
	{ 
		HRESULT hresult = wrap->dds1->QueryInterface( riid, ppvObject );
		if( SUCCEEDED( hresult ) ) GetWrap( ppvObject, wrap->lparam, riid );
		return hresult;
	}
	ULONG   __stdcall AddRef( WRAP* wrap ) 
	{ 
		AddRefWrap( wrap );
		return wrap->dds1->AddRef(); 
	}
	ULONG   __stdcall Release( WRAP* wrap ) 
	{ 	
		ULONG dwCount = wrap->dds1->Release();
		if( dwCount == 0 ) DeleteWrap( wrap );
		else ReleaseWrap( wrap );
		return dwCount;
	}
    // IDirectDrawSurface methods
    HRESULT __stdcall AddAttachedSurface( WRAP* wrap, LPDIRECTDRAWSURFACE lpDDSAttachedSurface ) { return wrap->dds1->AddAttachedSurface( GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall AddOverlayDirtyRect( WRAP* wrap, LPRECT lpRect ){ return wrap->dds1->AddOverlayDirtyRect(lpRect); }
	HRESULT __stdcall Blt( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx )
	{ 
		return BltProc( wrap, lpDestRect, lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx );
	}
    HRESULT __stdcall BltBatch( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags ) { return E_NOTIMPL; }
    HRESULT __stdcall BltFast( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ) { return wrap->dds1->BltFast( dwX, dwY, GetInterfacePtr( lpDDSrcSurface ), lpSrcRect, dwTrans ); }
    HRESULT __stdcall DeleteAttachedSurface( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE lpDDSAttachedSurface){ return wrap->dds1->DeleteAttachedSurface( dwFlags, GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall EnumAttachedSurfaces( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback ) 
	{ 
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpEnumSurfacesCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds1->EnumAttachedSurfaces( &e, &EnumSurfaces1Callback );
	}
	HRESULT __stdcall EnumOverlayZOrders( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback ) 
	{
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpfnCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds1->EnumOverlayZOrders( dwFlags, &e, &EnumSurfaces1Callback );
	}
	HRESULT __stdcall Flip( WRAP* wrap, LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride, DWORD dwFlags ) 
	{ 
		return FlipProc( wrap, (LPDIRECTDRAWSURFACE)lpDDSurfaceTargetOverride, dwFlags ); 
	}
    HRESULT __stdcall GetAttachedSurface( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE* lplpDDAttachedSurface ) 
	{ 
		HRESULT hResult = wrap->dds1->GetAttachedSurface( lpDDSCaps, lplpDDAttachedSurface );
		if( SUCCEEDED( hResult ) ) GetWrap( (void**)lplpDDAttachedSurface, wrap->lparam, IID_IDirectDrawSurface );
		return  hResult;
	} 
    HRESULT __stdcall GetBltStatus( WRAP* wrap, DWORD dwFlags ) { return wrap->dds1->GetBltStatus( dwFlags ); }
    HRESULT __stdcall GetCaps( WRAP* wrap, LPDDSCAPS lpDDSCaps ) { return wrap->dds1->GetCaps( lpDDSCaps ); }
    HRESULT __stdcall GetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper ) { return wrap->dds1->GetClipper( lplpDDClipper ); }
    HRESULT __stdcall GetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds1->GetColorKey( dwFlags, lpDDColorKey ); }
    HRESULT __stdcall GetDC( WRAP* wrap, HDC *lphDC ) { return wrap->dds1->GetDC( lphDC ); }
    HRESULT __stdcall GetFlipStatus( WRAP* wrap, DWORD dwFlags ){ return wrap->dds1->GetFlipStatus( dwFlags ); }
    HRESULT __stdcall GetOverlayPosition( WRAP* wrap, LPLONG lplX, LPLONG lplY ) { return wrap->dds1->GetOverlayPosition( lplX, lplY ); }
    HRESULT __stdcall GetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette ) { return wrap->dds1->GetPalette( lplpDDPalette ); }
	HRESULT __stdcall GetPixelFormat( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat ) { return wrap->dds1->GetPixelFormat( lpDDPixelFormat ); }
    HRESULT __stdcall GetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc ) { return wrap->dds1->GetSurfaceDesc( lpDDSurfaceDesc ); }
	HRESULT __stdcall Initialize( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc )
	{ 
		HRESULT hResult = wrap->dds1->Initialize( GetInterfacePtr( lpDD ), lpDDSurfaceDesc ); 
		if( SUCCEEDED( hResult ) ) wrap->lparam = (long) lpDD;
		return hResult;
	}
    HRESULT __stdcall IsLost( WRAP* wrap ) { return wrap->dds1->IsLost(); }
    HRESULT __stdcall Lock( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent ) { return wrap->dds1->Lock( lpDestRect, lpDDSurfaceDesc, dwFlags, hEvent ); }
    HRESULT __stdcall ReleaseDC( WRAP* wrap, HDC hDC ) { return wrap->dds1->ReleaseDC( hDC ); }
    HRESULT __stdcall Restore( WRAP* wrap ) { return wrap->dds1->Restore(); }
    HRESULT __stdcall SetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper ) { return wrap->dds1->SetClipper( lpDDClipper ); }
    HRESULT __stdcall SetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds1->SetColorKey( dwFlags,lpDDColorKey ); }
    HRESULT __stdcall SetOverlayPosition( WRAP* wrap, LONG lX, LONG lY ) { return wrap->dds1->SetOverlayPosition( lX,lY ); }
    HRESULT __stdcall SetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette ) { return wrap->dds1->SetPalette( lpDDPalette ); }
    HRESULT __stdcall Unlock( WRAP* wrap, LPVOID lpRect ) { return wrap->dds1->Unlock( lpRect ); }
	HRESULT __stdcall UpdateOverlay( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ){ return wrap->dds1->UpdateOverlay( lpSrcRect, GetInterfacePtr( lpDDDestSurface ), lpDestRect, dwFlags, lpDDOverlayFx ); }
    HRESULT __stdcall UpdateOverlayDisplay( WRAP* wrap, DWORD dwFlags ) { return wrap->dds1->UpdateOverlayDisplay( dwFlags ); }
    HRESULT __stdcall UpdateOverlayZOrder( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE lpDDSReference ) { return wrap->dds1->UpdateOverlayZOrder( dwFlags, GetInterfacePtr( lpDDSReference ) ); }
};

namespace dds2
{	
	// IUnknown methods       
	HRESULT __stdcall QueryInterface( WRAP* wrap, const IID& riid, void** ppvObject ) 
	{ 
		HRESULT hresult = wrap->dds2->QueryInterface( riid, ppvObject );
		if( SUCCEEDED( hresult ) ) GetWrap( ppvObject, wrap->lparam, riid );
		return hresult;
	}
	ULONG   __stdcall AddRef( WRAP* wrap ) 
	{ 
		AddRefWrap( wrap );
		return wrap->dds2->AddRef(); 
	}
	ULONG   __stdcall Release( WRAP* wrap ) 
	{ 	
		ULONG dwCount = wrap->dds2->Release();
		if( dwCount == 0 ) DeleteWrap( wrap );
		else ReleaseWrap( wrap );
		return dwCount;
	}
    // IDirectDrawSurface methods
    HRESULT __stdcall AddAttachedSurface( WRAP* wrap, LPDIRECTDRAWSURFACE2 lpDDSAttachedSurface ) { return wrap->dds2->AddAttachedSurface( GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall AddOverlayDirtyRect( WRAP* wrap, LPRECT lpRect ){ return wrap->dds2->AddOverlayDirtyRect(lpRect); }
	HRESULT __stdcall Blt( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE2 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx )
	{ 
		return BltProc( wrap, lpDestRect, (LPDIRECTDRAWSURFACE) lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx );
	}
    HRESULT __stdcall BltBatch( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags ) { return E_NOTIMPL; }
    HRESULT __stdcall BltFast( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE2 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ) { return wrap->dds2->BltFast( dwX, dwY, GetInterfacePtr( lpDDSrcSurface ), lpSrcRect, dwTrans ); }
    HRESULT __stdcall DeleteAttachedSurface( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE2 lpDDSAttachedSurface){ return wrap->dds2->DeleteAttachedSurface( dwFlags, GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall EnumAttachedSurfaces( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback ) 
	{ 
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpEnumSurfacesCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds2->EnumAttachedSurfaces( &e, &EnumSurfaces1Callback );
	}
	HRESULT __stdcall EnumOverlayZOrders( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback ) 
	{
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpfnCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds2->EnumOverlayZOrders( dwFlags, &e, &EnumSurfaces1Callback );
	}
    HRESULT __stdcall Flip( WRAP* wrap, LPDIRECTDRAWSURFACE2 lpDDSurfaceTargetOverride, DWORD dwFlags ) 
	{ 
		return FlipProc( wrap, (LPDIRECTDRAWSURFACE)lpDDSurfaceTargetOverride, dwFlags ); 
	}
    HRESULT __stdcall GetAttachedSurface( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE2* lplpDDAttachedSurface ) 
	{ 
		HRESULT hResult = wrap->dds2->GetAttachedSurface( lpDDSCaps, lplpDDAttachedSurface );
		if( SUCCEEDED( hResult ) ) GetWrap( (void**)lplpDDAttachedSurface, wrap->lparam, IID_IDirectDrawSurface2 );
		return  hResult;
	} 
    HRESULT __stdcall GetBltStatus( WRAP* wrap, DWORD dwFlags ) { return wrap->dds2->GetBltStatus( dwFlags ); }
    HRESULT __stdcall GetCaps( WRAP* wrap, LPDDSCAPS lpDDSCaps ) { return wrap->dds2->GetCaps( lpDDSCaps ); }
    HRESULT __stdcall GetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper ) { return wrap->dds2->GetClipper( lplpDDClipper ); }
    HRESULT __stdcall GetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds2->GetColorKey( dwFlags, lpDDColorKey ); }
    HRESULT __stdcall GetDC( WRAP* wrap, HDC *lphDC ) { return wrap->dds2->GetDC( lphDC ); }
    HRESULT __stdcall GetFlipStatus( WRAP* wrap, DWORD dwFlags ){ return wrap->dds2->GetFlipStatus( dwFlags ); }
    HRESULT __stdcall GetOverlayPosition( WRAP* wrap, LPLONG lplX, LPLONG lplY ) { return wrap->dds2->GetOverlayPosition( lplX, lplY ); }
    HRESULT __stdcall GetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette ) { return wrap->dds2->GetPalette( lplpDDPalette ); }
	HRESULT __stdcall GetPixelFormat( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat ) { return wrap->dds2->GetPixelFormat( lpDDPixelFormat ); }
    HRESULT __stdcall GetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc ) { return wrap->dds2->GetSurfaceDesc( lpDDSurfaceDesc ); }
	HRESULT __stdcall Initialize( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc )
	{ 
		HRESULT hResult = wrap->dds2->Initialize( GetInterfacePtr( lpDD ), lpDDSurfaceDesc ); 
		if( SUCCEEDED( hResult ) ) wrap->lparam = (long) lpDD;
		return hResult;
	}
    HRESULT __stdcall IsLost( WRAP* wrap ) { return wrap->dds2->IsLost(); }
    HRESULT __stdcall Lock( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent ) { return wrap->dds2->Lock( lpDestRect, lpDDSurfaceDesc, dwFlags, hEvent ); }
    HRESULT __stdcall ReleaseDC( WRAP* wrap, HDC hDC ) { return wrap->dds2->ReleaseDC( hDC ); }
    HRESULT __stdcall Restore( WRAP* wrap ) { return wrap->dds2->Restore(); }
    HRESULT __stdcall SetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper ) { return wrap->dds2->SetClipper( lpDDClipper ); }
    HRESULT __stdcall SetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds2->SetColorKey( dwFlags,lpDDColorKey ); }
    HRESULT __stdcall SetOverlayPosition( WRAP* wrap, LONG lX, LONG lY ) { return wrap->dds2->SetOverlayPosition( lX,lY ); }
    HRESULT __stdcall SetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette ) { return wrap->dds2->SetPalette( lpDDPalette ); }
    HRESULT __stdcall Unlock( WRAP* wrap, LPVOID lpRect ) { return wrap->dds2->Unlock( lpRect ); }
	HRESULT __stdcall UpdateOverlay( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE2 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ){ return wrap->dds2->UpdateOverlay( lpSrcRect, GetInterfacePtr( lpDDDestSurface ), lpDestRect, dwFlags, lpDDOverlayFx ); }
    HRESULT __stdcall UpdateOverlayDisplay( WRAP* wrap, DWORD dwFlags ) { return wrap->dds2->UpdateOverlayDisplay( dwFlags ); }
    HRESULT __stdcall UpdateOverlayZOrder( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE2 lpDDSReference ) { return wrap->dds2->UpdateOverlayZOrder( dwFlags, GetInterfacePtr( lpDDSReference ) ); }
    // added in v2
    HRESULT __stdcall GetDDInterface( WRAP* wrap, LPVOID* lplpDD ) 
	{ 
		HRESULT hResult = wrap->dds2->GetDDInterface( lplpDD );
		if( SUCCEEDED( hResult ) ) GetWrap( lplpDD, 0, IID_IDirectDraw ); 
		return hResult; 
	}
    HRESULT __stdcall PageLock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds2->PageLock( dwFlags ); }
    HRESULT __stdcall PageUnlock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds2->PageUnlock( dwFlags ); }
};

namespace dds3
{	
	// IUnknown methods       
	HRESULT __stdcall QueryInterface( WRAP* wrap, const IID& riid, void** ppvObject ) 
	{ 
		HRESULT hresult = wrap->dds3->QueryInterface( riid, ppvObject );
		if( SUCCEEDED( hresult ) ) GetWrap( ppvObject, wrap->lparam, riid );
		return hresult;
	}
	ULONG   __stdcall AddRef( WRAP* wrap ) 
	{ 
		AddRefWrap( wrap );
		return wrap->dds3->AddRef(); 
	}
	ULONG   __stdcall Release( WRAP* wrap ) 
	{ 	
		ULONG dwCount = wrap->dds3->Release();
		if( dwCount == 0 ) DeleteWrap( wrap );
		else ReleaseWrap( wrap );
		return dwCount;
	}
    // IDirectDrawSurface methods
    HRESULT __stdcall AddAttachedSurface( WRAP* wrap, LPDIRECTDRAWSURFACE3 lpDDSAttachedSurface ) { return wrap->dds3->AddAttachedSurface( GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall AddOverlayDirtyRect( WRAP* wrap, LPRECT lpRect ){ return wrap->dds3->AddOverlayDirtyRect(lpRect); }
	HRESULT __stdcall Blt( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE3 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx )
	{ 
		return BltProc( wrap, lpDestRect, (LPDIRECTDRAWSURFACE) lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx );
	}
    HRESULT __stdcall BltBatch( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags ) { return E_NOTIMPL; }
    HRESULT __stdcall BltFast( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE3 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ) { return wrap->dds3->BltFast( dwX, dwY, GetInterfacePtr( lpDDSrcSurface ), lpSrcRect, dwTrans ); }
    HRESULT __stdcall DeleteAttachedSurface( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE3 lpDDSAttachedSurface){ return wrap->dds3->DeleteAttachedSurface( dwFlags, GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall EnumAttachedSurfaces( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback ) 
	{ 
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpEnumSurfacesCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds3->EnumAttachedSurfaces( &e, &EnumSurfaces1Callback );
	}
	HRESULT __stdcall EnumOverlayZOrders( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback ) 
	{
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpfnCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds3->EnumOverlayZOrders( dwFlags, &e, &EnumSurfaces1Callback );
	}
    HRESULT __stdcall Flip( WRAP* wrap, LPDIRECTDRAWSURFACE3 lpDDSurfaceTargetOverride, DWORD dwFlags )
	{ 
		return FlipProc( wrap, (LPDIRECTDRAWSURFACE)lpDDSurfaceTargetOverride, dwFlags ); 
	}
    HRESULT __stdcall GetAttachedSurface( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE3* lplpDDAttachedSurface ) 
	{ 
		HRESULT hResult = wrap->dds3->GetAttachedSurface( lpDDSCaps, lplpDDAttachedSurface );
		if( SUCCEEDED( hResult ) ) GetWrap( (void**)lplpDDAttachedSurface, wrap->lparam, IID_IDirectDrawSurface3 );
		return  hResult;
	} 
    HRESULT __stdcall GetBltStatus( WRAP* wrap, DWORD dwFlags ) { return wrap->dds3->GetBltStatus( dwFlags ); }
    HRESULT __stdcall GetCaps( WRAP* wrap, LPDDSCAPS lpDDSCaps ) { return wrap->dds3->GetCaps( lpDDSCaps ); }
    HRESULT __stdcall GetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper ) { return wrap->dds3->GetClipper( lplpDDClipper ); }
    HRESULT __stdcall GetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds3->GetColorKey( dwFlags, lpDDColorKey ); }
    HRESULT __stdcall GetDC( WRAP* wrap, HDC *lphDC ) { return wrap->dds3->GetDC( lphDC ); }
    HRESULT __stdcall GetFlipStatus( WRAP* wrap, DWORD dwFlags ){ return wrap->dds3->GetFlipStatus( dwFlags ); }
    HRESULT __stdcall GetOverlayPosition( WRAP* wrap, LPLONG lplX, LPLONG lplY ) { return wrap->dds3->GetOverlayPosition( lplX, lplY ); }
    HRESULT __stdcall GetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette ) { return wrap->dds3->GetPalette( lplpDDPalette ); }
	HRESULT __stdcall GetPixelFormat( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat ) { return wrap->dds3->GetPixelFormat( lpDDPixelFormat ); }
    HRESULT __stdcall GetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc ) { return wrap->dds3->GetSurfaceDesc( lpDDSurfaceDesc ); }
	HRESULT __stdcall Initialize( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc )
	{ 
		HRESULT hResult = wrap->dds3->Initialize( GetInterfacePtr( lpDD ), lpDDSurfaceDesc ); 
		if( SUCCEEDED( hResult ) ) wrap->lparam = (long) lpDD;
		return hResult;
	}
    HRESULT __stdcall IsLost( WRAP* wrap ) { return wrap->dds3->IsLost(); }
    HRESULT __stdcall Lock( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent ) { return wrap->dds3->Lock( lpDestRect, lpDDSurfaceDesc, dwFlags, hEvent ); }
    HRESULT __stdcall ReleaseDC( WRAP* wrap, HDC hDC ) { return wrap->dds3->ReleaseDC( hDC ); }
    HRESULT __stdcall Restore( WRAP* wrap ) { return wrap->dds3->Restore(); }
    HRESULT __stdcall SetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper ) { return wrap->dds3->SetClipper( lpDDClipper ); }
    HRESULT __stdcall SetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds3->SetColorKey( dwFlags,lpDDColorKey ); }
    HRESULT __stdcall SetOverlayPosition( WRAP* wrap, LONG lX, LONG lY ) { return wrap->dds3->SetOverlayPosition( lX,lY ); }
    HRESULT __stdcall SetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette ) { return wrap->dds3->SetPalette( lpDDPalette ); }
    HRESULT __stdcall Unlock( WRAP* wrap, LPVOID lpRect ) { return wrap->dds3->Unlock( lpRect ); }
	HRESULT __stdcall UpdateOverlay( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE3 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ){ return wrap->dds3->UpdateOverlay( lpSrcRect, GetInterfacePtr( lpDDDestSurface ), lpDestRect, dwFlags, lpDDOverlayFx ); }
    HRESULT __stdcall UpdateOverlayDisplay( WRAP* wrap, DWORD dwFlags ) { return wrap->dds3->UpdateOverlayDisplay( dwFlags ); }
    HRESULT __stdcall UpdateOverlayZOrder( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE3 lpDDSReference ) { return wrap->dds3->UpdateOverlayZOrder( dwFlags, GetInterfacePtr( lpDDSReference ) ); }
    // added in v2
    HRESULT __stdcall GetDDInterface( WRAP* wrap, LPVOID* lplpDD ) 
	{ 
		HRESULT hResult = wrap->dds3->GetDDInterface( lplpDD );
		if( SUCCEEDED( hResult ) ) GetWrap( lplpDD, 0, IID_IDirectDraw ); 
		return hResult; 
	}
    HRESULT __stdcall PageLock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds3->PageLock( dwFlags ); }
    HRESULT __stdcall PageUnlock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds3->PageUnlock( dwFlags ); }
    // added in v3
    HRESULT __stdcall SetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC lpDDSD, DWORD dwFlags ) { return wrap->dds3->SetSurfaceDesc( lpDDSD, dwFlags ); }
};


namespace dds4
{	
	// IUnknown methods       
	HRESULT __stdcall QueryInterface( WRAP* wrap, const IID& riid, void** ppvObject ) 
	{ 
		HRESULT hresult = wrap->dds4->QueryInterface( riid, ppvObject );
		if( SUCCEEDED( hresult ) ) GetWrap( ppvObject, wrap->lparam, riid );
		return hresult;
	}
	ULONG   __stdcall AddRef( WRAP* wrap ) 
	{ 
		AddRefWrap( wrap );
		return wrap->dds4->AddRef(); 
	}
	ULONG   __stdcall Release( WRAP* wrap ) 
	{ 	
		ULONG dwCount = wrap->dds4->Release();
		if( dwCount == 0 ) DeleteWrap( wrap );
		else ReleaseWrap( wrap );
		return dwCount;
	}
    // IDirectDrawSurface methods
    HRESULT __stdcall AddAttachedSurface( WRAP* wrap, LPDIRECTDRAWSURFACE4 lpDDSAttachedSurface ) { return wrap->dds4->AddAttachedSurface( GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall AddOverlayDirtyRect( WRAP* wrap, LPRECT lpRect ){ return wrap->dds4->AddOverlayDirtyRect(lpRect); }
	HRESULT __stdcall Blt( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE4 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx )
	{ 
		return BltProc( wrap, lpDestRect, (LPDIRECTDRAWSURFACE) lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx );
	}
    HRESULT __stdcall BltBatch( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags ) { return E_NOTIMPL; }
    HRESULT __stdcall BltFast( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE4 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ) { return wrap->dds4->BltFast( dwX, dwY, GetInterfacePtr( lpDDSrcSurface ), lpSrcRect, dwTrans ); }
    HRESULT __stdcall DeleteAttachedSurface( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE4 lpDDSAttachedSurface){ return wrap->dds4->DeleteAttachedSurface( dwFlags, GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall EnumAttachedSurfaces( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK2 lpEnumSurfacesCallback ) 
	{ 
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpEnumSurfacesCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds4->EnumAttachedSurfaces( &e, &EnumSurfaces4Callback );
	}
	HRESULT __stdcall EnumOverlayZOrders( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK2 lpfnCallback ) 
	{
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpfnCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds4->EnumOverlayZOrders( dwFlags, &e, &EnumSurfaces4Callback );
	}
    HRESULT __stdcall Flip( WRAP* wrap, LPDIRECTDRAWSURFACE4 lpDDSurfaceTargetOverride, DWORD dwFlags ) 
	{ 
		return FlipProc( wrap, (LPDIRECTDRAWSURFACE)lpDDSurfaceTargetOverride, dwFlags ); 
	}
	HRESULT __stdcall GetAttachedSurface( WRAP* wrap, LPDDSCAPS2 lpDDSCaps, LPDIRECTDRAWSURFACE4* lplpDDAttachedSurface ) 
	{ 
		HRESULT hResult = wrap->dds4->GetAttachedSurface( lpDDSCaps, lplpDDAttachedSurface );
		if( SUCCEEDED( hResult ) ) GetWrap( (void**)lplpDDAttachedSurface, wrap->lparam, IID_IDirectDrawSurface4 );
		return  hResult;
	} 
    HRESULT __stdcall GetBltStatus( WRAP* wrap, DWORD dwFlags ) { return wrap->dds4->GetBltStatus( dwFlags ); }
    HRESULT __stdcall GetCaps( WRAP* wrap, LPDDSCAPS2 lpDDSCaps ) { return wrap->dds4->GetCaps( lpDDSCaps ); }
    HRESULT __stdcall GetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper ) { return wrap->dds4->GetClipper( lplpDDClipper ); }
    HRESULT __stdcall GetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds4->GetColorKey( dwFlags, lpDDColorKey ); }
    HRESULT __stdcall GetDC( WRAP* wrap, HDC *lphDC ) { return wrap->dds4->GetDC( lphDC ); }
    HRESULT __stdcall GetFlipStatus( WRAP* wrap, DWORD dwFlags ){ return wrap->dds4->GetFlipStatus( dwFlags ); }
    HRESULT __stdcall GetOverlayPosition( WRAP* wrap, LPLONG lplX, LPLONG lplY ) { return wrap->dds4->GetOverlayPosition( lplX, lplY ); }
    HRESULT __stdcall GetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette ) { return wrap->dds4->GetPalette( lplpDDPalette ); }
	HRESULT __stdcall GetPixelFormat( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat ) { return wrap->dds4->GetPixelFormat( lpDDPixelFormat ); }
    HRESULT __stdcall GetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC2 lpDDSurfaceDesc ) { return wrap->dds4->GetSurfaceDesc( lpDDSurfaceDesc ); }
	HRESULT __stdcall Initialize( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC2 lpDDSurfaceDesc )
	{ 
		HRESULT hResult = wrap->dds4->Initialize( GetInterfacePtr( lpDD ), lpDDSurfaceDesc ); 
		if( SUCCEEDED( hResult ) ) wrap->lparam = (long) lpDD;
		return hResult;
	}
    HRESULT __stdcall IsLost( WRAP* wrap ) { return wrap->dds4->IsLost(); }
    HRESULT __stdcall Lock( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC2 lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent ) { return wrap->dds4->Lock( lpDestRect, lpDDSurfaceDesc, dwFlags, hEvent ); }
    HRESULT __stdcall ReleaseDC( WRAP* wrap, HDC hDC ) { return wrap->dds4->ReleaseDC( hDC ); }
    HRESULT __stdcall Restore( WRAP* wrap ) { return wrap->dds4->Restore(); }
    HRESULT __stdcall SetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper ) { return wrap->dds4->SetClipper( lpDDClipper ); }
    HRESULT __stdcall SetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds4->SetColorKey( dwFlags,lpDDColorKey ); }
    HRESULT __stdcall SetOverlayPosition( WRAP* wrap, LONG lX, LONG lY ) { return wrap->dds4->SetOverlayPosition( lX,lY ); }
    HRESULT __stdcall SetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette ) { return wrap->dds4->SetPalette( lpDDPalette ); }
    HRESULT __stdcall Unlock( WRAP* wrap, LPRECT lpRect ) { return wrap->dds4->Unlock( lpRect ); }
	HRESULT __stdcall UpdateOverlay( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE4 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ){ return wrap->dds4->UpdateOverlay( lpSrcRect, GetInterfacePtr( lpDDDestSurface ), lpDestRect, dwFlags, lpDDOverlayFx ); }
    HRESULT __stdcall UpdateOverlayDisplay( WRAP* wrap, DWORD dwFlags ) { return wrap->dds4->UpdateOverlayDisplay( dwFlags ); }
    HRESULT __stdcall UpdateOverlayZOrder( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE4 lpDDSReference ) { return wrap->dds4->UpdateOverlayZOrder( dwFlags, GetInterfacePtr( lpDDSReference ) ); }
    // added in v2
    HRESULT __stdcall GetDDInterface( WRAP* wrap, LPVOID* lplpDD ) 
	{ 
		HRESULT hResult = wrap->dds4->GetDDInterface( lplpDD );
		if( SUCCEEDED( hResult ) ) GetWrap( lplpDD, 0, IID_IDirectDraw4 ); 
		return hResult; 
	}
    HRESULT __stdcall PageLock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds4->PageLock( dwFlags ); }
    HRESULT __stdcall PageUnlock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds4->PageUnlock( dwFlags ); }
    // added in v3
    HRESULT __stdcall SetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC2 lpDDSD, DWORD dwFlags ) { return wrap->dds4->SetSurfaceDesc( lpDDSD, dwFlags ); }
    // added in v4
    HRESULT __stdcall SetPrivateData( WRAP* wrap, const GUID & tag, LPVOID pData, DWORD cbSize, DWORD dwFlags ) { return wrap->dds4->SetPrivateData( tag, pData, cbSize, dwFlags ); }
    HRESULT __stdcall GetPrivateData( WRAP* wrap, const GUID & tag, LPVOID pBuffer, LPDWORD pcbBufferSize ) { return wrap->dds4->GetPrivateData( tag, pBuffer, pcbBufferSize ); }
    HRESULT __stdcall FreePrivateData( WRAP* wrap, const GUID & tag ) { return wrap->dds4->FreePrivateData( tag ); }
    HRESULT __stdcall GetUniquenessValue( WRAP* wrap, LPDWORD pValue ) { return wrap->dds4->GetUniquenessValue( pValue ); }
    HRESULT __stdcall ChangeUniquenessValue( WRAP* wrap ) { return wrap->dds4->ChangeUniquenessValue(); }
};
 

namespace dds7
{	
	// IUnknown methods       
	HRESULT __stdcall QueryInterface( WRAP* wrap, const IID& riid, void** ppvObject ) 
	{ 
		HRESULT hresult = wrap->dds7->QueryInterface( riid, ppvObject );
		if( SUCCEEDED( hresult ) ) GetWrap( ppvObject, wrap->lparam, riid );
		return hresult;
	}
	ULONG   __stdcall AddRef( WRAP* wrap ) 
	{ 
		AddRefWrap( wrap );
		return wrap->dds7->AddRef(); 
	}
	ULONG   __stdcall Release( WRAP* wrap ) 
	{ 	
		ULONG dwCount = wrap->dds7->Release();
		if( dwCount == 0 ) DeleteWrap( wrap );
		else ReleaseWrap( wrap );
		return dwCount;
	}
    // IDirectDrawSurface methods
    HRESULT __stdcall AddAttachedSurface( WRAP* wrap, LPDIRECTDRAWSURFACE7 lpDDSAttachedSurface ) { return wrap->dds7->AddAttachedSurface( GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall AddOverlayDirtyRect( WRAP* wrap, LPRECT lpRect ){ return wrap->dds7->AddOverlayDirtyRect(lpRect); }
	HRESULT __stdcall Blt( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE7 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx )
	{
		return BltProc( wrap, lpDestRect, (LPDIRECTDRAWSURFACE) lpDDSrcSurface, lpSrcRect, dwFlags, lpDDBltFx );
	}
    HRESULT __stdcall BltBatch( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags ) { return E_NOTIMPL; }
    HRESULT __stdcall BltFast( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE7 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ) { return wrap->dds7->BltFast( dwX, dwY, GetInterfacePtr( lpDDSrcSurface ), lpSrcRect, dwTrans ); }
    HRESULT __stdcall DeleteAttachedSurface( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE7 lpDDSAttachedSurface){ return wrap->dds7->DeleteAttachedSurface( dwFlags, GetInterfacePtr( lpDDSAttachedSurface ) ); }
    HRESULT __stdcall EnumAttachedSurfaces( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK7 lpEnumSurfacesCallback ) 
	{ 
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpEnumSurfacesCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds7->EnumAttachedSurfaces( &e, &EnumSurfaces7Callback );
	}
	HRESULT __stdcall EnumOverlayZOrders( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK7 lpfnCallback ) 
	{
		EnumStruct e;
		e.ddraw = (WRAP*)(wrap->lparam);
		e.lpOriginalCallback = lpfnCallback;
		e.lpOriginalContext = lpContext;
		return wrap->dds7->EnumOverlayZOrders( dwFlags, &e, &EnumSurfaces7Callback );
	}
    HRESULT __stdcall Flip( WRAP* wrap, LPDIRECTDRAWSURFACE7 lpDDSurfaceTargetOverride, DWORD dwFlags ) 
	{ 
		return FlipProc( wrap, (LPDIRECTDRAWSURFACE)lpDDSurfaceTargetOverride, dwFlags ); 
	}
	HRESULT __stdcall GetAttachedSurface( WRAP* wrap, LPDDSCAPS2 lpDDSCaps, LPDIRECTDRAWSURFACE7* lplpDDAttachedSurface ) 
	{ 
		HRESULT hResult = wrap->dds7->GetAttachedSurface( lpDDSCaps, lplpDDAttachedSurface );
		if( SUCCEEDED( hResult ) ) GetWrap( (void**)lplpDDAttachedSurface, wrap->lparam, IID_IDirectDrawSurface7 );
		return  hResult;
	} 
    HRESULT __stdcall GetBltStatus( WRAP* wrap, DWORD dwFlags ) { return wrap->dds7->GetBltStatus( dwFlags ); }
    HRESULT __stdcall GetCaps( WRAP* wrap, LPDDSCAPS2 lpDDSCaps ) { return wrap->dds7->GetCaps( lpDDSCaps ); }
    HRESULT __stdcall GetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper ) { return wrap->dds7->GetClipper( lplpDDClipper ); }
    HRESULT __stdcall GetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds7->GetColorKey( dwFlags, lpDDColorKey ); }
    HRESULT __stdcall GetDC( WRAP* wrap, HDC *lphDC ) { return wrap->dds7->GetDC( lphDC ); }
    HRESULT __stdcall GetFlipStatus( WRAP* wrap, DWORD dwFlags ){ return wrap->dds7->GetFlipStatus( dwFlags ); }
    HRESULT __stdcall GetOverlayPosition( WRAP* wrap, LPLONG lplX, LPLONG lplY ) { return wrap->dds7->GetOverlayPosition( lplX, lplY ); }
    HRESULT __stdcall GetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette ) { return wrap->dds7->GetPalette( lplpDDPalette ); }
	HRESULT __stdcall GetPixelFormat( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat ) { return wrap->dds7->GetPixelFormat( lpDDPixelFormat ); }
    HRESULT __stdcall GetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC2 lpDDSurfaceDesc ) { return wrap->dds7->GetSurfaceDesc( lpDDSurfaceDesc ); }
	HRESULT __stdcall Initialize( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC2 lpDDSurfaceDesc )
	{ 
		HRESULT hResult = wrap->dds7->Initialize( GetInterfacePtr( lpDD ), lpDDSurfaceDesc ); 
		if( SUCCEEDED( hResult ) ) wrap->lparam = (long) lpDD;
		return hResult;
	}
    HRESULT __stdcall IsLost( WRAP* wrap ) { return wrap->dds7->IsLost(); }
    HRESULT __stdcall Lock( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC2 lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent ) { return wrap->dds7->Lock( lpDestRect, lpDDSurfaceDesc, dwFlags, hEvent ); }
    HRESULT __stdcall ReleaseDC( WRAP* wrap, HDC hDC ) { return wrap->dds7->ReleaseDC( hDC ); }
    HRESULT __stdcall Restore( WRAP* wrap ) { return wrap->dds7->Restore(); }
    HRESULT __stdcall SetClipper( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper ) { return wrap->dds7->SetClipper( lpDDClipper ); }
    HRESULT __stdcall SetColorKey( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey ) { return wrap->dds7->SetColorKey( dwFlags,lpDDColorKey ); }
    HRESULT __stdcall SetOverlayPosition( WRAP* wrap, LONG lX, LONG lY ) { return wrap->dds7->SetOverlayPosition( lX,lY ); }
    HRESULT __stdcall SetPalette( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette ) { return wrap->dds7->SetPalette( lpDDPalette ); }
    HRESULT __stdcall Unlock( WRAP* wrap, LPRECT lpRect ) { return wrap->dds7->Unlock( lpRect ); }
	HRESULT __stdcall UpdateOverlay( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE7 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ){ return wrap->dds7->UpdateOverlay( lpSrcRect, GetInterfacePtr( lpDDDestSurface ), lpDestRect, dwFlags, lpDDOverlayFx ); }
    HRESULT __stdcall UpdateOverlayDisplay( WRAP* wrap, DWORD dwFlags ) { return wrap->dds7->UpdateOverlayDisplay( dwFlags ); }
    HRESULT __stdcall UpdateOverlayZOrder( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE7 lpDDSReference ) { return wrap->dds7->UpdateOverlayZOrder( dwFlags, GetInterfacePtr( lpDDSReference ) ); }
    // added in v2
    HRESULT __stdcall GetDDInterface( WRAP* wrap, LPVOID* lplpDD ) 
	{ 
		HRESULT hResult = wrap->dds7->GetDDInterface( lplpDD );
		if( SUCCEEDED( hResult ) ) GetWrap( lplpDD, 0, IID_IDirectDraw7 ); 
		return hResult; 
	}
    HRESULT __stdcall PageLock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds7->PageLock( dwFlags ); }
    HRESULT __stdcall PageUnlock( WRAP* wrap, DWORD dwFlags ) { return wrap->dds7->PageUnlock( dwFlags ); }
    // added in v3
    HRESULT __stdcall SetSurfaceDesc( WRAP* wrap, LPDDSURFACEDESC2 lpDDSD, DWORD dwFlags ) { return wrap->dds7->SetSurfaceDesc( lpDDSD, dwFlags ); }
    // added in v4
    HRESULT __stdcall SetPrivateData( WRAP* wrap, const GUID & tag, LPVOID pData, DWORD cbSize, DWORD dwFlags ) { return wrap->dds7->SetPrivateData( tag, pData, cbSize, dwFlags ); }
    HRESULT __stdcall GetPrivateData( WRAP* wrap, const GUID & tag, LPVOID pBuffer, LPDWORD pcbBufferSize ) { return wrap->dds7->GetPrivateData( tag, pBuffer, pcbBufferSize ); }
    HRESULT __stdcall FreePrivateData( WRAP* wrap, const GUID & tag ) { return wrap->dds7->FreePrivateData( tag ); }
    HRESULT __stdcall GetUniquenessValue( WRAP* wrap, LPDWORD pValue ) { return wrap->dds7->GetUniquenessValue( pValue ); }
    HRESULT __stdcall ChangeUniquenessValue( WRAP* wrap ) { return wrap->dds7->ChangeUniquenessValue(); }
    // added in v7
    HRESULT __stdcall SetPriority( WRAP* wrap, DWORD prio ) { return wrap->dds7->SetPriority( prio ); }
    HRESULT __stdcall GetPriority( WRAP* wrap, LPDWORD prio ) { return wrap->dds7->GetPriority( prio ); }
    HRESULT __stdcall SetLOD( WRAP* wrap, DWORD lod ) { return wrap->dds7->SetLOD( lod ); }
    HRESULT __stdcall GetLOD( WRAP* wrap, LPDWORD lod ) { return wrap->dds7->GetLOD( lod ); }
};

struct IDirectDrawSurface1_vtable
{
	HRESULT (__stdcall * QueryInterface)( WRAP* wrap, const IID& riid, void** ppvObject ); 
	ULONG   (__stdcall * AddRef)( WRAP* wrap ); 
	ULONG   (__stdcall * Release)( WRAP* wrap );
	HRESULT (__stdcall * AddAttachedSurface)( WRAP* wrap, LPDIRECTDRAWSURFACE lpDDSAttachedSurface );
	HRESULT (__stdcall * AddOverlayDirtyRect)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * Blt)( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx );
	HRESULT (__stdcall * BltBatch)( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags );
	HRESULT (__stdcall * BltFast)( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans );
	HRESULT (__stdcall * DeleteAttachedSurface)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE lpDDSAttachedSurface );
	HRESULT (__stdcall * EnumAttachedSurfaces)( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback );
	HRESULT (__stdcall * EnumOverlayZOrders)( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback );
	HRESULT (__stdcall * Flip)( WRAP* wrap, LPDIRECTDRAWSURFACE lpDDSurfaceTargetOverride, DWORD dwFlags );
	HRESULT (__stdcall * GetAttachedSurface)( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE *lplpDDAttachedSurface ); 
	HRESULT (__stdcall * GetBltStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetCaps)( WRAP* wrap, LPDDSCAPS lpDDSCaps );
	HRESULT (__stdcall * GetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper );
	HRESULT (__stdcall * GetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * GetDC)( WRAP* wrap, HDC *lphDC );
	HRESULT (__stdcall * GetFlipStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetOverlayPosition)( WRAP* wrap, LPLONG lplX, LPLONG lplY );
	HRESULT (__stdcall * GetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette );
	HRESULT (__stdcall * GetPixelFormat)( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat );
	HRESULT (__stdcall * GetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc );
	HRESULT (__stdcall * Initialize)( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc );
	HRESULT (__stdcall * IsLost)( WRAP* wrap );
	HRESULT (__stdcall * Lock)( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent );
	HRESULT (__stdcall * ReleaseDC)( WRAP* wrap, HDC hDC );
	HRESULT (__stdcall * Restore)( WRAP* wrap );
	HRESULT (__stdcall * SetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper );
	HRESULT (__stdcall * SetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * SetOverlayPosition)( WRAP* wrap, LONG lX, LONG lY );
	HRESULT (__stdcall * SetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette );
	HRESULT (__stdcall * Unlock)( WRAP* wrap, LPVOID lpRect );
	HRESULT (__stdcall * UpdateOverlay)( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx );
	HRESULT (__stdcall * UpdateOverlayDisplay)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * UpdateOverlayZOrder)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE lpDDSReference );
};

struct IDirectDrawSurface2_vtable
{
	HRESULT (__stdcall * QueryInterface)( WRAP* wrap, const IID& riid, void** ppvObject ); 
	ULONG   (__stdcall * AddRef)( WRAP* wrap ); 
	ULONG   (__stdcall * Release)( WRAP* wrap );
	HRESULT (__stdcall * AddAttachedSurface)( WRAP* wrap, LPDIRECTDRAWSURFACE2 lpDDSAttachedSurface ); 
	HRESULT (__stdcall * AddOverlayDirtyRect)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * Blt)( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE2 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx );
	HRESULT (__stdcall * BltBatch)( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags );
	HRESULT (__stdcall * BltFast)( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE2 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans );
	HRESULT (__stdcall * DeleteAttachedSurface)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE2 lpDDSAttachedSurface ); 
	HRESULT (__stdcall * EnumAttachedSurfaces)( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback ); 
	HRESULT (__stdcall * EnumOverlayZOrders)( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback );
	HRESULT (__stdcall * Flip)( WRAP* wrap, LPDIRECTDRAWSURFACE2 lpDDSurfaceTargetOverride, DWORD dwFlags ); 
	HRESULT (__stdcall * GetAttachedSurface)( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE2 *lplpDDAttachedSurface );
	HRESULT (__stdcall * GetBltStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetCaps)( WRAP* wrap, LPDDSCAPS lpDDSCaps );
	HRESULT (__stdcall * GetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper );
	HRESULT (__stdcall * GetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * GetDC)( WRAP* wrap, HDC *lphDC );
	HRESULT (__stdcall * GetFlipStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetOverlayPosition)( WRAP* wrap, LPLONG lplX, LPLONG lplY );
	HRESULT (__stdcall * GetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette );
	HRESULT (__stdcall * GetPixelFormat)( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat );
	HRESULT (__stdcall * GetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc );
	HRESULT (__stdcall * Initialize)( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc );
	HRESULT (__stdcall * IsLost)( WRAP* wrap );
	HRESULT (__stdcall * Lock)( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent );
	HRESULT (__stdcall * ReleaseDC)( WRAP* wrap, HDC hDC );
	HRESULT (__stdcall * Restore)( WRAP* wrap );
	HRESULT (__stdcall * SetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper );
	HRESULT (__stdcall * SetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * SetOverlayPosition)( WRAP* wrap, LONG lX, LONG lY );
	HRESULT (__stdcall * SetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette );
	HRESULT (__stdcall * Unlock)( WRAP* wrap, LPVOID lpRect );
	HRESULT (__stdcall * UpdateOverlay)( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE2 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx );
	HRESULT (__stdcall * UpdateOverlayDisplay)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * UpdateOverlayZOrder)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE2 lpDDSReference ); 
	HRESULT (__stdcall * GetDDInterface)( WRAP* wrap, LPVOID *lplpDD ); 
	HRESULT (__stdcall * PageLock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * PageUnlock)( WRAP* wrap, DWORD dwFlags );
};



struct IDirectDrawSurface3_vtable
{
	HRESULT (__stdcall * QueryInterface)( WRAP* wrap, const IID& riid, void** ppvObject ); 
	ULONG   (__stdcall * AddRef)( WRAP* wrap ); 
	ULONG   (__stdcall * Release)( WRAP* wrap );
	HRESULT (__stdcall * AddAttachedSurface)( WRAP* wrap, LPDIRECTDRAWSURFACE3 lpDDSAttachedSurface) ;
	HRESULT (__stdcall * AddOverlayDirtyRect)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * Blt)( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE3 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx );
	HRESULT (__stdcall * BltBatch)( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags );
	HRESULT (__stdcall * BltFast)( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE3 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ); 
	HRESULT (__stdcall * DeleteAttachedSurface)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE3 lpDDSAttachedSurface );
	HRESULT (__stdcall * EnumAttachedSurfaces)( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpEnumSurfacesCallback ); 
	HRESULT (__stdcall * EnumOverlayZOrders)( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK lpfnCallback ); 
	HRESULT (__stdcall * Flip)( WRAP* wrap, LPDIRECTDRAWSURFACE3 lpDDSurfaceTargetOverride, DWORD dwFlags ); 
	HRESULT (__stdcall * GetAttachedSurface)( WRAP* wrap, LPDDSCAPS lpDDSCaps, LPDIRECTDRAWSURFACE3 *lplpDDAttachedSurface ); 
	HRESULT (__stdcall * GetBltStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetCaps)( WRAP* wrap, LPDDSCAPS lpDDSCaps );
	HRESULT (__stdcall * GetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper );
	HRESULT (__stdcall * GetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * GetDC)( WRAP* wrap, HDC *lphDC );
	HRESULT (__stdcall * GetFlipStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetOverlayPosition)( WRAP* wrap, LPLONG lplX, LPLONG lplY );
	HRESULT (__stdcall * GetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette );
	HRESULT (__stdcall * GetPixelFormat)( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat );
	HRESULT (__stdcall * GetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC lpDDSurfaceDesc );
	HRESULT (__stdcall * Initialize)( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC lpDDSurfaceDesc ); 
	HRESULT (__stdcall * IsLost)( WRAP* wrap );
	HRESULT (__stdcall * Lock)( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent );
	HRESULT (__stdcall * ReleaseDC)( WRAP* wrap, HDC hDC );
	HRESULT (__stdcall * Restore)( WRAP* wrap );
	HRESULT (__stdcall * SetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper );
	HRESULT (__stdcall * SetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * SetOverlayPosition)( WRAP* wrap, LONG lX, LONG lY );
	HRESULT (__stdcall * SetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette );
	HRESULT (__stdcall * Unlock)( WRAP* wrap, LPVOID lpRect );
	HRESULT (__stdcall * UpdateOverlay)( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE3 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx ); 
	HRESULT (__stdcall * UpdateOverlayDisplay)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * UpdateOverlayZOrder)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE3 lpDDSReference ); 
	HRESULT (__stdcall * GetDDInterface)( WRAP* wrap, LPVOID *lplpDD ); 
	HRESULT (__stdcall * PageLock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * PageUnlock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * SetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC lpDDSD, DWORD dwFlags );
};

struct IDirectDrawSurface4_vtable
{
	HRESULT (__stdcall * QueryInterface)( WRAP* wrap, const IID& riid, void** ppvObject ); 
	ULONG   (__stdcall * AddRef)( WRAP* wrap ); 
	ULONG   (__stdcall * Release)( WRAP* wrap );
	HRESULT (__stdcall * AddAttachedSurface)( WRAP* wrap, LPDIRECTDRAWSURFACE4 lpDDSAttachedSurface );
	HRESULT (__stdcall * AddOverlayDirtyRect)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * Blt)( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE4 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx );
	HRESULT (__stdcall * BltBatch)( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags );
	HRESULT (__stdcall * BltFast)( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE4 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans ); 
	HRESULT (__stdcall * DeleteAttachedSurface)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE4 lpDDSAttachedSurface ); 
	HRESULT (__stdcall * EnumAttachedSurfaces)( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK2 lpEnumSurfacesCallback ); 
	HRESULT (__stdcall * EnumOverlayZOrders)( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK2 lpfnCallback ); 
	HRESULT (__stdcall * Flip)( WRAP* wrap, LPDIRECTDRAWSURFACE4 lpDDSurfaceTargetOverride, DWORD dwFlags ); 
	HRESULT (__stdcall * GetAttachedSurface)( WRAP* wrap, LPDDSCAPS2 lpDDSCaps, LPDIRECTDRAWSURFACE4 *lplpDDAttachedSurface ); 
	HRESULT (__stdcall * GetBltStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetCaps)( WRAP* wrap, LPDDSCAPS2 lpDDSCaps );
	HRESULT (__stdcall * GetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper );
	HRESULT (__stdcall * GetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * GetDC)( WRAP* wrap, HDC *lphDC );
	HRESULT (__stdcall * GetFlipStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetOverlayPosition)( WRAP* wrap, LPLONG lplX, LPLONG lplY );
	HRESULT (__stdcall * GetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette );
	HRESULT (__stdcall * GetPixelFormat)( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat );
	HRESULT (__stdcall * GetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC2 lpDDSurfaceDesc );
	HRESULT (__stdcall * Initialize)( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC2 lpDDSurfaceDesc ); 
	HRESULT (__stdcall * IsLost)( WRAP* wrap );
	HRESULT (__stdcall * Lock)( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC2 lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent );
	HRESULT (__stdcall * ReleaseDC)( WRAP* wrap, HDC hDC );
	HRESULT (__stdcall * Restore)( WRAP* wrap);
	HRESULT (__stdcall * SetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper );
	HRESULT (__stdcall * SetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * SetOverlayPosition)( WRAP* wrap, LONG lX, LONG lY );
	HRESULT (__stdcall * SetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette );
	HRESULT (__stdcall * Unlock)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * UpdateOverlay)( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE4 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx );
	HRESULT (__stdcall * UpdateOverlayDisplay)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * UpdateOverlayZOrder)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE4 lpDDSReference );
	HRESULT (__stdcall * GetDDInterface)( WRAP* wrap, LPVOID *lplpDD ); 
	HRESULT (__stdcall * PageLock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * PageUnlock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * SetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC2 lpDDSD, DWORD dwFlags );
	HRESULT (__stdcall * SetPrivateData)( WRAP* wrap, const GUID & tag, LPVOID pData, DWORD cbSize, DWORD dwFlags );
	HRESULT (__stdcall * GetPrivateData)( WRAP* wrap, const GUID & tag, LPVOID pBuffer, LPDWORD pcbBufferSize );
	HRESULT (__stdcall * FreePrivateData)( WRAP* wrap, const GUID & tag );
	HRESULT (__stdcall * GetUniquenessValue)( WRAP* wrap, LPDWORD pValue );
	HRESULT (__stdcall * ChangeUniquenessValue)( WRAP* wrap );
};

struct IDirectDrawSurface7_vtable
{
	HRESULT (__stdcall * QueryInterface)( WRAP* wrap, const IID& riid, void** ppvObject ); 
	ULONG   (__stdcall * AddRef)( WRAP* wrap ); 
	ULONG   (__stdcall * Release)( WRAP* wrap );
	HRESULT (__stdcall * AddAttachedSurface)( WRAP* wrap, LPDIRECTDRAWSURFACE7 lpDDSAttachedSurface ); 
	HRESULT (__stdcall * AddOverlayDirtyRect)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * Blt)( WRAP* wrap, LPRECT lpDestRect, LPDIRECTDRAWSURFACE7 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwFlags, LPDDBLTFX lpDDBltFx );
	HRESULT (__stdcall * BltBatch)( WRAP* wrap, LPDDBLTBATCH lpDDBltBatch, DWORD dwCount, DWORD dwFlags );
	HRESULT (__stdcall * BltFast)( WRAP* wrap, DWORD dwX, DWORD dwY, LPDIRECTDRAWSURFACE7 lpDDSrcSurface, LPRECT lpSrcRect, DWORD dwTrans );
	HRESULT (__stdcall * DeleteAttachedSurface)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE7 lpDDSAttachedSurface );
	HRESULT (__stdcall * EnumAttachedSurfaces)( WRAP* wrap, LPVOID lpContext, LPDDENUMSURFACESCALLBACK7 lpEnumSurfacesCallback ); 
	HRESULT (__stdcall * EnumOverlayZOrders)( WRAP* wrap, DWORD dwFlags, LPVOID lpContext, LPDDENUMSURFACESCALLBACK7 lpfnCallback ); 
	HRESULT (__stdcall * Flip)( WRAP* wrap, LPDIRECTDRAWSURFACE7 lpDDSurfaceTargetOverride, DWORD dwFlags ); 
	HRESULT (__stdcall * GetAttachedSurface)( WRAP* wrap, LPDDSCAPS2 lpDDSCaps, LPDIRECTDRAWSURFACE7* lplpDDAttachedSurface ); 
	HRESULT (__stdcall * GetBltStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetCaps)( WRAP* wrap, LPDDSCAPS2 lpDDSCaps );
	HRESULT (__stdcall * GetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER *lplpDDClipper );
	HRESULT (__stdcall * GetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * GetDC)( WRAP* wrap, HDC *lphDC );
	HRESULT (__stdcall * GetFlipStatus)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * GetOverlayPosition)( WRAP* wrap, LPLONG lplX, LPLONG lplY );
	HRESULT (__stdcall * GetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE *lplpDDPalette );
	HRESULT (__stdcall * GetPixelFormat)( WRAP* wrap, LPDDPIXELFORMAT lpDDPixelFormat );
	HRESULT (__stdcall * GetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC2 lpDDSurfaceDesc );
	HRESULT (__stdcall * Initialize)( WRAP* wrap, LPDIRECTDRAW lpDD, LPDDSURFACEDESC2 lpDDSurfaceDesc );
	HRESULT (__stdcall * IsLost)( WRAP* wrap );
	HRESULT (__stdcall * Lock)( WRAP* wrap, LPRECT lpDestRect, LPDDSURFACEDESC2 lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent );
	HRESULT (__stdcall * ReleaseDC)( WRAP* wrap, HDC hDC );
	HRESULT (__stdcall * Restore)( WRAP* wrap );
	HRESULT (__stdcall * SetClipper)( WRAP* wrap, LPDIRECTDRAWCLIPPER lpDDClipper );
	HRESULT (__stdcall * SetColorKey)( WRAP* wrap, DWORD dwFlags, LPDDCOLORKEY lpDDColorKey );
	HRESULT (__stdcall * SetOverlayPosition)( WRAP* wrap, LONG lX, LONG lY );
	HRESULT (__stdcall * SetPalette)( WRAP* wrap, LPDIRECTDRAWPALETTE lpDDPalette );
	HRESULT (__stdcall * Unlock)( WRAP* wrap, LPRECT lpRect );
	HRESULT (__stdcall * UpdateOverlay)( WRAP* wrap, LPRECT lpSrcRect, LPDIRECTDRAWSURFACE7 lpDDDestSurface, LPRECT lpDestRect, DWORD dwFlags, LPDDOVERLAYFX lpDDOverlayFx );
	HRESULT (__stdcall * UpdateOverlayDisplay)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * UpdateOverlayZOrder)( WRAP* wrap, DWORD dwFlags, LPDIRECTDRAWSURFACE7 lpDDSReference ); 
	HRESULT (__stdcall * GetDDInterface)( WRAP* wrap, LPVOID *lplpDD ); 
	HRESULT (__stdcall * PageLock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * PageUnlock)( WRAP* wrap, DWORD dwFlags );
	HRESULT (__stdcall * SetSurfaceDesc)( WRAP* wrap, LPDDSURFACEDESC2 lpDDSD, DWORD dwFlags );
	HRESULT (__stdcall * SetPrivateData)( WRAP* wrap, const GUID & tag, LPVOID pData, DWORD cbSize, DWORD dwFlags );
	HRESULT (__stdcall * GetPrivateData)( WRAP* wrap, const GUID & tag, LPVOID pBuffer, LPDWORD pcbBufferSize );
	HRESULT (__stdcall * FreePrivateData)( WRAP* wrap, const GUID & tag );
	HRESULT (__stdcall * GetUniquenessValue)( WRAP* wrap, LPDWORD pValue );
	HRESULT (__stdcall * ChangeUniquenessValue)( WRAP* wrap );
	HRESULT (__stdcall * SetPriority)( WRAP* wrap, DWORD prio );
	HRESULT (__stdcall * GetPriority)( WRAP* wrap, LPDWORD prio );
	HRESULT (__stdcall * SetLOD)( WRAP* wrap, DWORD lod );
	HRESULT (__stdcall * GetLOD)( WRAP* wrap, LPDWORD lod );
};

IDirectDrawSurface1_vtable dds1_vtable = {
	dds1::QueryInterface, 
	dds1::AddRef, 
	dds1::Release,
	dds1::AddAttachedSurface,
	dds1::AddOverlayDirtyRect,
	dds1::Blt,
	dds1::BltBatch,
	dds1::BltFast,
	dds1::DeleteAttachedSurface,
	dds1::EnumAttachedSurfaces,
	dds1::EnumOverlayZOrders,
	dds1::Flip,
	dds1::GetAttachedSurface, 
	dds1::GetBltStatus,
	dds1::GetCaps,
	dds1::GetClipper,
	dds1::GetColorKey,
	dds1::GetDC,
	dds1::GetFlipStatus,
	dds1::GetOverlayPosition,
	dds1::GetPalette,
	dds1::GetPixelFormat,
	dds1::GetSurfaceDesc,
	dds1::Initialize,
	dds1::IsLost,
	dds1::Lock,
	dds1::ReleaseDC,
	dds1::Restore,
	dds1::SetClipper,
	dds1::SetColorKey,
	dds1::SetOverlayPosition,
	dds1::SetPalette,
	dds1::Unlock,
	dds1::UpdateOverlay,
	dds1::UpdateOverlayDisplay,
	dds1::UpdateOverlayZOrder
};

IDirectDrawSurface2_vtable dds2_vtable = {
	dds2::QueryInterface, 
	dds2::AddRef, 
	dds2::Release,
	dds2::AddAttachedSurface,
	dds2::AddOverlayDirtyRect,
	dds2::Blt,
	dds2::BltBatch,
	dds2::BltFast,
	dds2::DeleteAttachedSurface,
	dds2::EnumAttachedSurfaces,
	dds2::EnumOverlayZOrders,
	dds2::Flip,
	dds2::GetAttachedSurface, 
	dds2::GetBltStatus,
	dds2::GetCaps,
	dds2::GetClipper,
	dds2::GetColorKey,
	dds2::GetDC,
	dds2::GetFlipStatus,
	dds2::GetOverlayPosition,
	dds2::GetPalette,
	dds2::GetPixelFormat,
	dds2::GetSurfaceDesc,
	dds2::Initialize,
	dds2::IsLost,
	dds2::Lock,
	dds2::ReleaseDC,
	dds2::Restore,
	dds2::SetClipper,
	dds2::SetColorKey,
	dds2::SetOverlayPosition,
	dds2::SetPalette,
	dds2::Unlock,
	dds2::UpdateOverlay,
	dds2::UpdateOverlayDisplay,
	dds2::UpdateOverlayZOrder,	
	dds2::GetDDInterface, 
	dds2::PageLock,
	dds2::PageUnlock
};

IDirectDrawSurface3_vtable dds3_vtable = {
	dds3::QueryInterface, 
	dds3::AddRef, 
	dds3::Release,
	dds3::AddAttachedSurface,
	dds3::AddOverlayDirtyRect,
	dds3::Blt,
	dds3::BltBatch,
	dds3::BltFast,
	dds3::DeleteAttachedSurface,
	dds3::EnumAttachedSurfaces,
	dds3::EnumOverlayZOrders,
	dds3::Flip,
	dds3::GetAttachedSurface, 
	dds3::GetBltStatus,
	dds3::GetCaps,
	dds3::GetClipper,
	dds3::GetColorKey,
	dds3::GetDC,
	dds3::GetFlipStatus,
	dds3::GetOverlayPosition,
	dds3::GetPalette,
	dds3::GetPixelFormat,
	dds3::GetSurfaceDesc,
	dds3::Initialize,
	dds3::IsLost,
	dds3::Lock,
	dds3::ReleaseDC,
	dds3::Restore,
	dds3::SetClipper,
	dds3::SetColorKey,
	dds3::SetOverlayPosition,
	dds3::SetPalette,
	dds3::Unlock,
	dds3::UpdateOverlay,
	dds3::UpdateOverlayDisplay,
	dds3::UpdateOverlayZOrder,	
	dds3::GetDDInterface, 
	dds3::PageLock,
	dds3::PageUnlock,
	dds3::SetSurfaceDesc
};

IDirectDrawSurface4_vtable dds4_vtable = {
	dds4::QueryInterface, 
	dds4::AddRef, 
	dds4::Release,
	dds4::AddAttachedSurface,
	dds4::AddOverlayDirtyRect,
	dds4::Blt,
	dds4::BltBatch,
	dds4::BltFast,
	dds4::DeleteAttachedSurface,
	dds4::EnumAttachedSurfaces,
	dds4::EnumOverlayZOrders,
	dds4::Flip,
	dds4::GetAttachedSurface, 
	dds4::GetBltStatus,
	dds4::GetCaps,
	dds4::GetClipper,
	dds4::GetColorKey,
	dds4::GetDC,
	dds4::GetFlipStatus,
	dds4::GetOverlayPosition,
	dds4::GetPalette,
	dds4::GetPixelFormat,
	dds4::GetSurfaceDesc,
	dds4::Initialize,
	dds4::IsLost,
	dds4::Lock,
	dds4::ReleaseDC,
	dds4::Restore,
	dds4::SetClipper,
	dds4::SetColorKey,
	dds4::SetOverlayPosition,
	dds4::SetPalette,
	dds4::Unlock,
	dds4::UpdateOverlay,
	dds4::UpdateOverlayDisplay,
	dds4::UpdateOverlayZOrder,	
	dds4::GetDDInterface, 
	dds4::PageLock,
	dds4::PageUnlock,
	dds4::SetSurfaceDesc,
	dds4::SetPrivateData,
	dds4::GetPrivateData,
	dds4::FreePrivateData,
	dds4::GetUniquenessValue,
	dds4::ChangeUniquenessValue
};

IDirectDrawSurface7_vtable dds7_vtable = {
	dds7::QueryInterface, 
	dds7::AddRef, 
	dds7::Release,
	dds7::AddAttachedSurface,
	dds7::AddOverlayDirtyRect,
	dds7::Blt,
	dds7::BltBatch,
	dds7::BltFast,
	dds7::DeleteAttachedSurface,
	dds7::EnumAttachedSurfaces,
	dds7::EnumOverlayZOrders,
	dds7::Flip,
	dds7::GetAttachedSurface, 
	dds7::GetBltStatus,
	dds7::GetCaps,
	dds7::GetClipper,
	dds7::GetColorKey,
	dds7::GetDC,
	dds7::GetFlipStatus,
	dds7::GetOverlayPosition,
	dds7::GetPalette,
	dds7::GetPixelFormat,
	dds7::GetSurfaceDesc,
	dds7::Initialize,
	dds7::IsLost,
	dds7::Lock,
	dds7::ReleaseDC,
	dds7::Restore,
	dds7::SetClipper,
	dds7::SetColorKey,
	dds7::SetOverlayPosition,
	dds7::SetPalette,
	dds7::Unlock,
	dds7::UpdateOverlay,
	dds7::UpdateOverlayDisplay,
	dds7::UpdateOverlayZOrder,	
	dds7::GetDDInterface, 
	dds7::PageLock,
	dds7::PageUnlock,
	dds7::SetSurfaceDesc,
	dds4::SetPrivateData,
	dds7::GetPrivateData,
	dds7::FreePrivateData,
	dds7::GetUniquenessValue,
	dds7::ChangeUniquenessValue,
	dds7::SetPriority,
	dds7::GetPriority,
	dds7::SetLOD,
	dds7::GetLOD
};